﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;

namespace SendKeysTest
{
    class SendKeys
    {
        [StructLayout(LayoutKind.Sequential)]
        private struct MOUSEINPUT
        {
            int dx;
            int dy;
            uint mouseData;
            uint dwFlags;
            uint time;
            IntPtr dwExtraInfo;
        }

        [StructLayout(LayoutKind.Sequential)]
        private struct KEYBDINPUT
        {
            public ushort wVk;
            public ushort wScan;
            public uint dwFlags;
            public uint time;
            public IntPtr dwExtraInfo;
        }

        [StructLayout(LayoutKind.Sequential)]
        private struct HARDWAREINPUT
        {
            uint uMsg;
            ushort wParamL;
            ushort wParamH;
        }

        [StructLayout(LayoutKind.Explicit)]
        private struct INPUT
        {
            [FieldOffset(0)]
            public uint type;
            [FieldOffset(4)] //*
            public MOUSEINPUT mi;
            [FieldOffset(4)] //*
            public KEYBDINPUT ki;
            [FieldOffset(4)] //*
            public HARDWAREINPUT hi;
        }

        private const uint INPUT_KEYBOARD = 1;
        private const uint KEYEVENTF_KEYUP = 0x0002;
        private const uint KEYEVENTF_UNICODE = 0x0004;

        [DllImport("user32.dll", SetLastError = true)]
        private static extern uint SendInput(uint nInputs,
            [MarshalAs(UnmanagedType.LPArray), In] INPUT[] pInputs, int cbSize);


        public static void Send(String input)
        {
            var inputs = new INPUT[input.Length * 2];
            for (int i = 0; i < input.Length; i++)
            {
                inputs[i * 2] = new INPUT()
                {
                    type = INPUT_KEYBOARD,
                    ki = new KEYBDINPUT()
                    {
                        wVk = 0,
                        wScan = input[i],
                        dwFlags = KEYEVENTF_UNICODE
                    }
                };
                inputs[i * 2 + 1] = new INPUT()
                {
                    type = INPUT_KEYBOARD,
                    ki = new KEYBDINPUT()
                    {
                        wVk = 0,
                        wScan = input[i],
                        dwFlags = KEYEVENTF_UNICODE | KEYEVENTF_KEYUP
                    }
                };
            }
            SendInput((uint)inputs.Length, inputs, Marshal.SizeOf<INPUT>());
        }
    }
}
